Autodesk官方最新的.NET教程(二)(C#版)

原创 2005年06月01日 09:54:00
2  .NET AutoCAD 向导及Editor
        在第一章中,我们使用的是类库模板,这样就不得不手工加入acdbmdg. dll 和acmgd.dll这两个引用。在这一章中,我们将使用AutoCAD托管C#应用程序向导来创建.NET工程,它会自动加入以上两个引用。在开始本章之前,你首先得安装ObjectARX向导(ObjectARX2006开发包的/utils/ObjARXWiz/ArxWizards.msi)。
 
1)    启动Visual Studio .NET,选择”文件>新建>工程”(File> New> Project)。在新建工程对话框中选择工程类型为”Visual C#工程”,然后选择“AutoCAD Managed CS Project Application”模板。在工程名字框中输入”Lab2”,然后选择工程存放的位置。点击确定按钮,“AutoCAD Managed CSharp Application Wizard”对话框将会出现。因为我们不需要使用非托管代码,所以不要选择“Enable Unmanaged Debugging”项。“Registered Developer Symbol”将会使用你在安装ObjectARX向导时输入的值。单击”finish”按钮来创建工程。
2)    下面来看一下向导生成的工程。在解决方案浏览器中,你会看到acdbmgd 和 acmgd已经被引用了。在Class.cs文件中,“Autodesk.AutoCAD.Runtime”命名空间已被导入,工程使用“Registered Developer Symbol”的名字来命名缺省的公有类。向导还为类加入了一个CommandMethod属性和一个函数,它们用于AutoCAD命令。
3)    在前一章中,我们使用一个“Autodesk.AutoCAD.EditorInput.Editor”类的实例对象在AutoCAD命令行上输出文本。在这一章中,我们将使用这个类来提示用户在AutoCAD图形中选择一个点,然后将用户选择的点的x,y,z值显示出来。和前一章一样,请导入Autodesk.AutoCAD.ApplicationServices 和 Autodesk.AutoCAD.EditorInput命名空间。
4)    把向导生成的CommandMethod属性的值改为有意义一些的名字如“selectPoint”(函数的名字可以不用修改)。PromptPointOptions类用来设置提示字符串和其它的一些控制提示的选项。这个类的一个实例作为参数被传入到Editor.GetPoint方法。在函数的开始,实例化这个类,设置字符串参数为“Select a point”。因为 Editor.GetPoint方法会返回一个PromptPointResult类的实例对象,所以我们也要把它实例化。
 
PromptPointOptions prPointOptions =
new PromptPointOptions("Select a point");
PromptPointResult prPointRes;
 
5)    接下来实例化一个Editor类的对象并使用参数为PromptPointOptions对象的GetPoint方法。用GetPoint方法的返回值来给上面声明的PromptPointResult对象赋值。赋值好以后,我们可以测试PromptPointResult对象的状态,如果不是OK就返回。
 
prPointRes = ed.GetPoint(prPointOptions);
       if (prPointRes.Status != PromptStatus.OK)
       {
           ed.WriteMessage("Error");
}
 
6)    如果PromptPointResult对象返回了一个有效的点,我们就可以使用WriteMessage方法把结果输出到命令行。PromptPointResult.Value的ToString方法使输出非常容易:
 
ed.WriteMessage("You selected point "
 prPointRes.Value.ToString)
 
7)    按F5来运行一个调试AutoCAD的进程。(注意:向导已经设置好用acad.exe来调试)在AutoCAD命令行中输入NETLOAD,选择Lab2.dll并打开。在命令行中输入你起的命令名字(selectPoint)。在选择点的提示下,单击图形中的任一点。如果一切正常的话,你可以在命令行中看到你所选的点的坐标值。在Class.cs文件的“ed.WriteMessage("Error");”行加入断点,然后再次运行selectPoint命令。这一次,在选择点的提示下按ESC键而不是选择一个点。PromptPointResult对象的状态就不是OK了,所以上面代码中的if语句就会被执行,“ed.WriteMessage("Error")”;语句就会被调用。
8)    接下来我们将加入另外一个命令,它可以获取两个点之间的距离。向导没有添加命令的功能,所以我们必须手工添加。在Class.cs文件的选择点的函数(getPoint)下面添加一个名为getDistance的新命令。加入命令的方法请参考上一章的内容或本章的源代码,这里就不列出了。使用CommandMethod属性并使字符串参数为“getdistance”或其它类似的名字。在命令的函数中使用PromptDistanceOptions代替PromptPointOptions。当然GetDistance方法的返回值是一个PromptDoubleResult类的实例对象,所以请用PromptDoubleResult来代替PromptPointResult:
 
PromptDistanceOptions prDistOptions = new    
     PromptDistanceOptions("Find distance, select first point:");
          PromptDoubleResult prDistRes;
prDistRes = ed.GetDistance(prDistOptions);
 
9)       和前面的命令一样,也可以测试PromptDoubleResult的状态,然后用WriteMessage方法在命令行中显示值。
 
if (prDistRes.Status != PromptStatus.OK)
         {
             ed.WriteMessage("Error");
         }
      else
         {
ed.WriteMessage("The distance is: " + prDistRes.Value.ToString());
   
  }
 
 

Autodesk官方最新的.NET教程(七)(C#版)

第7章 事件本章将讨论AutoCAD中的事件。我们将介绍事件处理函数的使用,特别是监视AutoCAD命令的事件处理函数和监视被AutoCAD命令修改的对象的事件处理函数。在解释怎样在C#中实现Auto...
  • zenghf7878
  • zenghf7878
  • 2005-06-22 09:12:00
  • 3002

Autodesk官方最新的.NET教程(一)(C#版)

第 1章         Hello World: 访问 ObjectARX .NET 封装类       在这一章中,我们将使用Visual Studio .NET来创建一个新的类库工程。通过这个工...
  • zenghf7878
  • zenghf7878
  • 2005-06-01 09:48:00
  • 5475

Autodesk官方最新的.NET教程(三)(C#版)

 第 3 章  数据库基础:  创建我们自己的Employee 对象打开Lab3文件夹下的Lab3工程文件,或或接着Lab2的代码。在这一章中,我们将创建一个‘Employee 对象’(包括一个圆,一...
  • zenghf7878
  • zenghf7878
  • 2005-06-02 11:06:00
  • 2798

Autodesk官方最新的.NET教程(二)(C#版)

第2章  .NET AutoCAD 向导及Editor类        在第一章中,我们使用的是类库模板,这样就不得不手工加入acdbmdg. dll 和acmgd.dll这两个引用。在这一章中,我们...
  • cdo
  • cdo
  • 2005-06-07 17:41:00
  • 1009

Autodesk官方最新的.NET教程(C#版)中文版-----附源代码

  • 2009年02月26日 22:33
  • 145KB
  • 下载

Autodesk官方最新的.NET教程(五)(C#版)

第 5 章 用户互操作:提示和选择背景提示通常包含一个描述性信息,伴随一个停止以让用户理解所给的信息并输入数据。数据可以通过多种方式被输入,如通过命令行、对话框或AutoCAD编辑窗口。给出的提示要遵...
  • zenghf7878
  • zenghf7878
  • 2005-06-13 14:46:00
  • 2230

Autodesk官方最新AutoCAD.net开发教程(C#版含代码)共8章

  • 2017年04月28日 19:21
  • 4.88MB
  • 下载

Autodesk官方最新的.NET教程(五)(C#版)

第 5 章 用户互操作:提示和选择背景提示通常包含一个描述性信息,伴随一个停止以让用户理解所给的信息并输入数据。数据可以通过多种方式被输入,如通过命令行、对话框或AutoCAD编辑窗口。给出的提示要遵...
  • sjzwl
  • sjzwl
  • 2007-10-23 20:11:00
  • 557

Autodesk官方最新的.NET教程(六)(C#版)

 第6章  更多的用户界面:添加自定义数据在本章中,我们将介绍.NET API的用户界面部分能做些什么。我们首先将介绍一个自定义上下文菜单(快捷菜单)。接下来我们将实现一个无模式可停靠的面板(一个真正...
  • zenghf7878
  • zenghf7878
  • 2005-06-21 10:21:00
  • 3586

Autodesk官方最新的.net教程(C#版)

  • 2011年11月30日 21:43
  • 200KB
  • 下载
收藏助手
不良信息举报
您举报文章:Autodesk官方最新的.NET教程(二)(C#版)
举报原因:
原因补充:

(最多只允许输入30个字)